<?php

// No direct access.
defined('_JEXEC') or die;

abstract class AbstractCommonClubsModelJoin
{
    
    protected $tablename;
    protected $alias;
    protected $condition;
    /**
     * @var AbstractCommonClubsModelColumn[]
     */
    protected $columns;
    
    public function __construct($alias, $condition, $colums, $tablename = null)
    {
        /// XXX Some checks need to be performed
        $this->alias = $alias;
        $this->condition = $condition;
        $this->columns = $colums;
        
        if(empty($tablename))
            $this->tablename = $alias;
        else 
            $this->tablename = $alias;
    }
    
    public function getAlias()
    {
        return $this->alias;
    }
    
    public function getTableName()
    {
        return $this->tablename;
    }
    
    public function getOnCondition()
    {
        return $this->condition;
    }
    
    public function getColumns()
    {
        return $this->columns;
    }
    
    /**
     * 
     * @param JDatabaseQuery $q
     */
    public function join($q)
    {
        $str = "{$this->tablename} AS {$this->alias}";
        if(isset($this->condition))
            $str .= " ON {$this->condition}";
        $this->addJoin($q, $str);
        
        foreach($this->columns as $c)
        {
            $qc = $q->q("{$this->alias}." . $c->getColumn(), $c->getAlias());
            $q->select($qc);
        }
    }
    
    /**
     * 
     * @param JDatabaseQuery $q
     * @param String $str
     */
    protected abstract function addJoin($q, $str);
    
    public function unpackExternalReferencesFromKeys(&$vals)
    {
        foreach($this->columns as $col)
        {
            $alias = $col->getAlias();
            $vals[$alias] = $col->unpackValue($vals[$alias]);
        }
    }
    
}
