<?php

// No direct access.
defined('_JEXEC') or die;

class CommonClubsModelUserassoc extends AbstractCommonClubsModel
{
    protected function getFactory()
    {
        return new CommonClubsModelFactoryUserassoc();
    }

    /**
     * 
     * @return CommonClubsModelUser
     */
    public function getUser()
    {
        return $this->getValues()['user'];
    }
    
    /**
     * 
     * @return CommonClubsModelPosition
     */
    public function getPosition()
    {
        return $this->getValues()['position'];
    }
    
    /**
     * 
     * @return CommonClubsModelClub
     */
    public function getClub()
    {
        return $this->getValues()['club'];
    }
    
    public function setUser($user)
    {
        $this->setValue('user', $user);
    }
    
    public function setPosition($position)
    {
        $this->setValue('position', $position);
    }
    
    public function setClub($club)
    {
        $this->setValue('club', $club);
    }
    
    public function isAdmin()
    {
        return $this->getValues()['admin'] == 1;
    }
    
    public function setAdmin($admin)
    {
        if($admin)
            $this->setValue('admin', 1);
        else 
            $this->setValue('admin', 0);
    }
    
    public function getAddress()
    {
        return $this->getValues()['address'];
    }
    
    public function setAddress($address)
    {
        $this->setValue('address', $address);
    }
    
    public function getMail()
    {
        return $this->getValues()['mail'];
    }
    
    public function setMail($mail)
    {
        $this->setValue('mail', $mail);
    }
    
    public function getPhone()
    {
        return $this->getValues()['phone'];
    }
    
    public function setPhone($phone)
    {
        $this->setValue('phone', $phone);
    }
    
    public function getState()
    {
        return $this->getValues()['state'];
    }
    
    public function setState($state)
    {
        switch(strtolower($state))
        {
            case 'vacant':
            case 'temporary':
            case 'regular':
                $state = strtolower($state);
                break;
                
            default:
                throw new Exception("Unknown state \"$state\" found.");
        }
        $this->setValue('state', $state);
    }
    
}
