<?php

use Joomla\CMS\Factory;

// No direct access.
defined('_JEXEC') or die;

class ClubsControllerUser extends AbstractClubsController
{
    
    protected function getSingleBaseName()
    {
        return 'user';
    }
    
    protected function rawDataIsValid($values)
    {
        if(! parent::rawDataIsValid($values))
            return false;
        
        if($this->passwordIsSet($values))
        {
            if( ! $this->passwordIsValid($values))
                return false;
        }
        
        return true;
    }
    
    private function passwordIsSet($values)
    {
        return isset($values['pwd']) && strlen($values['pwd']) > 0;
    }
    
    private function passwordIsValid($values)
    {
        $pwd = $values['pwd'];
        $pwdConfirm = $values['pwdConfirm'];
        
        if(trim($pwd) != trim($pwdConfirm))
        {
            Factory::getApplication()->enqueueMessage('Die Passwörter stimmen nicht überein.', 'error');
            return false;
        }
        
        // FIXME Check password strength
//         if(! ClubsUser::checkPasswordStrength(trim($pwd)))
//         {
//             Factory::getApplication()->enqueueMessage('Das Passwort ist zu schwach.', 'error');
//             return false;
//         }
        
        return true;
    }
    
    protected function getFactory()
    {
        return new CommonClubsModelFactoryUser();
    }

    /**
     * 
     * {@inheritDoc}
     * @see AbstractClubsController::filterObject()
     * @param CommonClubsModelUser $obj
     */
    protected function filterObject($obj, $values)
    {
//         if($obj->isNew() && (empty($values['pwd']) || strlen($values['pwd']) == 0) )
            
        if(isset($values['pwd']) && strlen($values['pwd']) > 0)
        {
            $obj->setPassword($values['pwd']);
        }
    }
    
    /**
     * {@inheritDoc}
     * @see AbstractClubsController::objectValid()
     * @param CommonClubsModelUser $obj
     */
    protected function objectValid($obj)
    {
        if(! $obj->isPasswordSet())
        {
            Factory::getApplication()->enqueueMessage('Kein Passwort wurde vergeben.', 'error');
            return false;
        }
        
        return true;
    }

    protected function filterRaw(&$values)
    {
        unset($values['password']);
    }

    protected function additionalData()
    {
        return array(
            'pwd' => new CommonClubsControllerMappingString('Passwort'),
            'pwdConfirm' => new CommonClubsControllerMappingString('Passwortwiederholung')
        );
    }

}
