<?php

// No direct access.
use Joomla\CMS\MVC\View\HtmlView;
use Joomla\CMS\Router\Route;

defined('_JEXEC') or die;

abstract class AbstractClubsViewList extends HtmlView
{
    
    /**
     * @var AbstractCommonClubsModel
     */
    protected $objects;
    protected $delUrl;
    protected $addUrl;
    protected $changeUrl;
    
    private $prepared = FALSE;
    
    public function prepareDisplay()
    {
        $this->prepared = TRUE;
        
        $this->objects = $this->loadObjects();
        $baseUrl = "index.php?option=com_clubs";
        $viewName = $this->getSingleViewName();
        $controllerName = $this->getControllerName();
        
        $this->addUrl = Route::_("$baseUrl&view=$viewName&id=new");
        $this->changeUrl = Route::_("$baseUrl&view=$viewName&id=__ID__");
        $this->delUrl = Route::_("$baseUrl&task=$controllerName.delete&id=__ID__");
    }
    
    public function display($tpl = null)
    {
        if(!$this->prepared)
            $this->prepareDisplay();
            
        parent::display($tpl);
    }
    
    protected abstract function getSingleBaseName();
    
    protected function getControllerName()
    {
        return $this->getSingleBaseName();
    }
    
    protected function getSingleViewName()
    {
        return $this->getSingleBaseName();
    }
    
    /**
     * @return AbstractCommonClubsModelFactory
     */
    protected abstract function getFactory();
    
    protected function loadObjects()
    {
        $factory = $this->getFactory();
        return $factory->loadElements();
    }
    
}
