<?php

use Joomla\CMS\Factory;
use Joomla\CMS\MVC\View\HtmlView;
use Joomla\CMS\Router\Route;

// No direct access.
defined('_JEXEC') or die;

abstract class AbstractClubsViewSingle extends HtmlView
{
    
    protected $address;
    /**
     * @var AbstractCommonClubsModel
     */
    protected $object;
    protected $isNew;
    protected $id;
    
    private $prepared = FALSE;
    
    public function prepareDisplay()
    {
        $this->prepared = TRUE;
        
        $input = Factory::getApplication()->input;
        $id =  $input->get->get('id');
        
        $controllerName = $this->getControllerName();
        
        if($id === 'new')
        {
            $this->address = Route::_("index.php?option=com_clubs&task={$controllerName}.new");
            $this->object = $this->createNewObject();
            $this->isNew = true;
        }
        else if(is_numeric($id))
        {
            $id = (int) $id;
            $this->address = Route::_("index.php?option=com_clubs&task={$controllerName}.change&id=$id");
            $this->object = $this->loadObject($id);
            $this->isNew = false;
        }
        else
            throw new Exception('Need a valid object id.');
        
        $jsonData = $input->get->get('data', null, 'json');
        if($jsonData !== null)
        {
            $this->object->unpack($jsonData);
            
        }
        
        $this->id = $id;
    }
    
    public function display($tpl = null)
    {
        if(!$this->prepared)
            $this->prepareDisplay();
        
        parent::display($tpl);
    }
    
    protected abstract function getControllerName();
    
    /**
     * @return AbstractCommonClubsModelFactory
     */
    protected abstract function getFactory();
    
    protected function createNewObject()
    {
        $factory = $this->getFactory();
        return $factory->createNew();
    }
    
    protected function loadObject($id)
    {
        $factory = $this->getFactory();
        return $factory->loadById($id);
    }
    
}
