<?php

// No direct access.
defined('_JEXEC') or die;

abstract class AbstractCommonClubsModelColumn
{
    
    protected $alias;
    protected $column;
    /**
     * @var AbstractCommonClubsControllerMapping
     */
    protected $filter;
    
    public function getAlias()
    {
        return $this->alias;
    }
    
    public function getColumn()
    {
        return $this->column;
    }
    
    public abstract function isSimpleType();
    
    public function __construct($alias, $filter, $column = null)
    {
        $this->alias = $alias;
        $this->filter = $filter;
        if(isset($column))
            $this->column = $column;
        else
            $this->column = $alias;
    }
    
    /**
     * @param JDatabaseQuery $q
     */
    public function select($q)
    {
        $q->select($q->qn($this->column, $this->alias));
    }
    
    /**
     * 
     * @param JDatabaseQuery $q
     * @param mixed $value
     */
    public abstract function getQuotedValue($q,$value);
    
    /**
     * 
     * @param JDatabaseQuery $q
     */
    public function getQuotedColumnName($q)
    {
        return $q->qn($this->column);
    }
    
    public function packValue($value)
    {
        return $value;
    }
    
    public function unpackValue($value)
    {
        return $value;
    }
    
    public function getFilter()
    {
        return $this->filter;
    }
    
}
