<?php

// No direct access.
defined('_JEXEC') or die;

class CommonClubsModelClub extends AbstractCommonClubsModel
{
    
    protected function getFactory()
    {
        return new CommonClubsModelFactoryClub();
    }
    
    public function getName()
    {
        return $this->getValues()['name'];
    }
    
    public function getAddress()
    {
        return $this->getValues()['address'];
    }
    
    public function getCity()
    {
        return $this->getValues()['city'];
    }
    
    public function getHomepage()
    {
        return $this->getValues()['homepage'];
    }
    
    public function getMail()
    {
        return $this->getValues()['mail'];
    }
    
    public function getIban()
    {
        return $this->getValues()['iban'];
    }
    
    public function getBic()
    {
        return $this->getValues()['bic'];
    }
    
    public function isCharitable()
    {
        return $this->getValues()['charitable'];
    }
    
    public function getPresident()
    {
        return $this->getValues()['president'];
    }
    
    public function getPlaces()
    {
        return $this->fetchAssociatedElements(new CommonClubsModelFactoryPlace(), 'clubid');
    }
    
    private function getOfferAssocs()
    {
        return $this->fetchAssociatedElements(new CommonClubsModelFactoryOfferassoc(), 'clubid');
    }
    
    public function getOffers()
    {
        $assocs = $this->getOfferAssocs();
        
        $offersFactory = new CommonClubsModelFactoryOffer();
        $allOffers = $offersFactory->loadElements();
        
        $ret = array();
        foreach($allOffers as $offer)
        {
            $arr = array(
                'offer' => $offer,
                'valid' => false
            );
            
            $id = $offer->getId();
            foreach($assocs as $a)
            {
                $oid = $a->getOffer()->getId();
                if($id === $oid)
                {
                    $arr['valid'] = true;
                    break;
                }
            }
                
            $ret[] = $arr;
        }
        return $ret;
    }
    
    /**
     * @param int[] $ids
     */
    public function setOfferIds($ids)
    {
        $dbo = $this->getFactory()->loadById($this->getId());
        $currentOffersAssocs = $dbo->getOfferAssocs();
        $currentIds = array_map(function($obj){
            return $obj->getOffer()->getId();
        }, $currentOffersAssocs);
        
        $newIds = array_diff($ids, $currentIds);
        $delIds = array_diff($currentIds, $ids);
        
        $offerAssocFactory = new CommonClubsModelFactoryOfferassoc();
        $offerFactory = new CommonClubsModelFactoryOffer();
        
        foreach($delIds as $id)
        {
            $delId = (int) $id;
            $delObjs = $offerAssocFactory->loadElements("clubid = {$this->getId()} AND offerid = $delId");
            foreach($delObjs as $o)
                $o->delete();
        }
        
        foreach($newIds as $id)
        {
            $newId = (int) $id;
            $o = $offerAssocFactory->createNew();
            $o->setOffer($offerFactory->loadById($newId));
            $o->setClub($this);
            $o->save();
        }
    }
    
    public function getUsers()
    {
        return $this->fetchAssociatedElements(new CommonClubsModelFactoryUserassoc(), 'clubid');
    }
    
    protected function prepareDelete($db)
    {
        $q = $db->getQuery(true);
        $q->delete('#__club_user_assocs')->where("clubid = {$this->getId()}");
        $db->setQuery($q);
        $db->execute();
        
        $q = $db->getQuery(true);
        $q->delete('#__club_places')->where("clubid = {$this->getId()}");
        $db->setQuery($q);
        $db->execute();
        
        $q = $db->getQuery(true);
        $q->delete('#__club_offer_assocs')->where("clubid = {$this->getId()}");
        $db->setQuery($q);
        $db->execute();
    }
}
