
jQuery(function($){
	
	function closeDialog() {
		$('#dialog-club > .dialog').html('');
		$('body').removeClass('form-disabled');
		$('#dialog-club').addClass('dialog-hidden');
	}
	
	function openDialog(data) {
//		console.log(data);
		$('#dialog-club > .dialog').html(data);
		$('body').addClass('form-disabled');
		$('#dialog-club').removeClass('dialog-hidden');
	}
	
	$('#new-position').click(function(ev){
		ev.preventDefault();
		
		var url = $('#new-position').attr('href');
		$.get(url, function(data){
			openDialog(data);
		});
		
	});
	
	$(document).on('click', '#clubposition-abort', function(ev){
		ev.preventDefault();
		closeDialog();
	});
	
	$(document).on('change', '#clubposition-state', function(){
		if($('#clubposition-state').val() == "vacant")
			$('#clubposition-user').addClass('dialog-entry-hidden');
		else
			$('#clubposition-user').removeClass('dialog-entry-hidden');
	});
	
	$(document).on('click', '#clubposition-save', function(ev){
		ev.preventDefault();
		
		var data = $('#clubposition-form').serializeArray();
		
		$.post($('#clubposition-form').attr('action'), data, function(data){
//			console.log(data)
			
			if(data.success)
			{
				console.log("all right!");
				
				var url = "index.php?option=com_clubs&view=clubposition&layout=row&id=" + data.data.id + "&club=" + $('#hidden-id').html();
				console.log(url);
				
				if(data.data.new) {
					$.get(url, function(data2){
						$("#userassocs").append(data2);
						closeDialog();
					});
				} else {
					$.get(url, function(data2){
						$('#userassoc-' + data.data.id).html(data2);
						closeDialog();
					});
				}
			}
			else
			{
				alert(data.message);
			}
		});
	});
	
	$(document).on('click', '.edit-position', function(ev){
		ev.preventDefault();
		
		var url = ev.currentTarget.href;
		
		$.get(url, function(data){
			openDialog(data);
		});
	});
	
	$(document).on('click', '.del-position', function(ev){
		ev.preventDefault();
		
		if(confirm("Der Eintrag wird endgültig gelöscht werden. OK?")) {
			var url = ev.currentTarget.href;
			$.get(url, function(d){
				if(d.success) {
					$('#userassoc-' + d.data.id).remove();
				}
			});
		}
		
	});
	
	$(window).on('beforeunload', function(){return "Wollen Sie die Seite wirklich verlassen? M&ouml;glicherweise sind nicht alle Daten gesichert.";});
	$('.form-exit').click(function(){
		$(window).off('beforeunload');
	});
	
});
