<?php

use Joomla\CMS\Toolbar\ToolbarHelper;
use Joomla\CMS\Router\Route;

// No direct access.
defined('_JEXEC') or die;

class ClubsViewUser extends AbstractClubsViewSingle
{
    
    public function display($tpl = null)
    {
        $this->prepareDisplay();
        
        if($this->isNew)
        {
            $this->jobs = array();
        }
        else
        {
            $factory = new CommonClubsModelFactoryUser();
            $user = $factory->loadById($this->id);
            
            $positions = $user->getPositions();
            
            $clubFactory = new CommonClubsModelFactoryClub();
            $clubsPresident = $clubFactory->loadElements("main.president = {$this->id}");
            
            $jobs = array();
            
            foreach($clubsPresident as $club)
            {
                $job = array(
                    'club' => $club->getName(),
                    'city' => $club->getCity(),
                    'position' => 'Vorsitzender',
                    'url' => Route::_("index.php?option=com_clubs&view=club&id={$club->getId()}")
                );
                $jobs[] = $job;
            }
            foreach($positions as $p)
            {
                $c = $p->getClub();
                $job = array(
                    'club' => $c->getName(),
                    'city' => $c->getCity(),
                    'position' => $p->getPosition()->getName(),
                    'url' => Route::_("index.php?option=com_clubs&view=club&id={$c->getId()}")
                );
                $jobs[] = $job;
            }
            $this->jobs = $jobs;
        }
        
        ToolbarHelper::title('Club-Management - Person', 'user');
        parent::display($tpl);
    }
    
    protected function getControllerName()
    {
        return 'user';
    }

    protected function getFactory()
    {
        return new CommonClubsModelFactoryUser();
    }

    
}
